      FUNCTION SFG6R(X,A,B,EPS,ITMAX,IERR)
      REAL A,B,X,EPS,SFG6R,SYS053,BT,R1,R2,R3
      INTEGER ITMAX,IERR
      COMMON/SFG6R2/ITREAL
      DATA SYS053/3.4E38/
      IERR=0
      IF(X.GE.0.0.OR.X.LE.1.0) GO TO 10
      IERR=65
      GO TO 50
   10 IF(A.GT.0.0.AND.B.GT.0.0) GO TO 70
      IERR=66
      GO TO 50
   70 IF(X.NE.0.0.OR.X.NE.1.0) GO TO 20
      BT=0.0
      GO TO 30
   20 CALL SF66R(A+B,R1,IERR)
      CALL SF66R(A,R2,IERR)
      CALL SF66R(B,R3,IERR)
      BT=EXP(R1-R2-R3+A*ALOG(X)+B*ALOG(1.0-X))
   30 IF(X.GE.(A+1.0)/(A+B+1.0)) GO TO 40
      SFG6R=BT*SFG6R1(X,A,B,EPS,ITMAX,IERR)/A
      IF(IERR.NE.0) GO TO 50
      GO TO 60
   40 SFG6R=1.0-BT*SFG6R1(1.0-X,B,A,EPS,ITMAX,IERR)/B
      IF(IERR.EQ.0) GO TO 60
   50 SFG6R=SYS053
      CALL UTSF12(IERR,52)
   60 RETURN
      END
